

function [cost,y,shapeParam,cost_derivative]=comp_mpe_cost(W,X,shape_list,const_log,uncorr)


if nargin<5
   uncorr=false;
   if nargin<4
      const_log=[];
   end
end
if iscell(W)
   %%%%%%%%%%%%%%%%%%%%%%%%Not done yet%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
   error('not done for cells.')
   [N,T]=size(X{1});
   K=length(X);
   y=X;
   y_all=zeros(K,N,T);
   cost=0;

   for k = 1:K
      y{k} = W{k}*X{k};
      y_all(k,:,:) = y{k};  % subj X comp X T
      cost=cost-log(abs(det(W{k})));
   end

   for n=1:N
      y_comp=squeeze(y_all(:,n,:)); % subj X T
      gip=dot(y_comp,y_comp);
      dcost=mean(sqrt(gip));
      cost=cost+dcost;
   end
   %%%%%%%%%%%%%%%%%%%%%%%%Not done yet%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   
else
   scalesources=false;
   [N,T,K]=size(X);
   shapeParam=shape_list(1)*ones(N,1);
   Y=X;
   cost=0;
   if isempty(const_log)
      xi_shape=gamma((2+K)./(2*shape_list)) / ...
         K ./ gamma(K/2./shape_list);
      const_Ck=shape_list.*gamma(K/2).*xi_shape.^(K/2)./ ...
         (pi^(K/2)*gamma(K./(2*shape_list)));      
      const_log=-log(const_Ck);
   end

   if scalesources
      for k = 1:K
         Y(:,:,k) = W(:,:,k)*X(:,:,k);
         ypower=diag(Y(:,:,k)*Y(:,:,k)')/T;
         W(:,:,k) = W(:,:,k)./repmat(sqrt(ypower),1,N);
      end
   end
   
   i=1;

   for k = 1:K
      Y(:,:,k) = W(:,:,k)*X(:,:,k);
      cost=cost-log(abs(det(W(:,:,k))));
   end % K
   
   
   for n=1:N
      yn=shiftdim(Y(n,:,:)).'; % K x T
      if uncorr
         gip=dot(yn,yn);
         dcost=-K*log(rhat)+rhat*mean(sqrt(gip));
      else
         CovN=yn*yn'/T;
         gip=dot(yn,CovN\yn);
         dcost_all=(const_log + 0.5*log(det(CovN)));
         for ishape=1:length(shape_list)
            dcost_all(ishape)= dcost_all(ishape) + ...
              xi_shape(ishape)^shape_list(ishape)* ...
               mean(gip.^shape_list(ishape));
         end
         [dcost,ishape]=min(dcost_all);
         shapeParam(n)=shape_list(ishape);
      end
      cost=cost+dcost;
   end
   y=Y;

   if nargout>3     
      error('Not done yet.')
      bool_numerical_derivative=false;
      cost_derivative=zeros(N,K,N); % derivative is computed assuming that each set of SCV demixing vectors are constant.
      if bool_numerical_derivative
         cost_derivative_numerical=zeros(N,K,N);
      end
      for n=1:N
         yn=shiftdim(Y(n,:,:)).'; % K x T
         SigN=yn*yn'/T;
         invSigN=inv(SigN);
         gip=dot(yn,invSigN*yn);         
         for k=1:K
            xx=bsxfun(@times,X(:,:,k),1./sqrt(gip));

            wnk=W(n,:,k); wnk=wnk(:);

            cost_derivative(n,k,:)=sqrt(K+1)*mean(bsxfun(@times,invSigN(k,:)*yn,xx),2);
            if 1==1
               % Find direction orthogonal to space spanned by excluded components demixing
               % matrix via QR decomposition
               [Q,R]=qr(W(nout,:,k)'); %#ok<NASGU>
               hnk=Q(:,end); % hn should be orthogonal to W(nout,:,k)'
               cost_derivative(n,k,:) = squeeze(cost_derivative(n,k,:)) - hnk/(hnk'*wnk);
            end

            if bool_numerical_derivative
               dd=0.00001;
               cost_d_nk=zeros(N,1);
               for nn=1:N
                  wnkplus=wnk;
                  wnkplus(nn)=wnkplus(nn)+dd;
                  wnkplus=vecnorm(wnkplus);
                  Wplus=W;
                  Wplus(n,:,k)=wnkplus';
                  costplus=comp_multivarlaplace_corr_cost(Wplus,X);

                  wnkminus=wnk;
                  wnkminus(nn)=wnkminus(nn)-dd;
                  wnkminus=vecnorm(wnkminus);
                  Wminus=W;
                  Wminus(n,:,k)=wnkminus';
                  costminus=comp_multivarlaplace_corr_cost(Wminus,X);

                  cost_d_nk(nn)=(costplus-costminus)/(2*dd);

               end % nn=1:N
               cost_derivative_numerical(n,k,:)=cost_d_nk;

               alph=0.001;
               dw=vecnorm(squeeze(cost_derivative(n,k,:)));
               dw_theory=vecnorm(dw-wnk'*dw*wnk);
               wnew_theory = vecnorm(wnk - alph*dw_theory);
               W_theory=W; W_theory(n,:,k)=wnew_theory;
               cost_theory=comp_multivarlaplace_corr_cost(W_theory,X);

               dw=vecnorm(squeeze(cost_derivative_numerical(n,k,:)));
               dw_numerical=vecnorm(dw-wnk'*dw*wnk);
               wnew_numerical = vecnorm(wnk - alph*dw_numerical);
               W_numerical=W; W_numerical(n,:,k)=wnew_numerical;
               cost_numerical=comp_multivarlaplace_corr_cost(W_numerical,X);

               disp(['n,k=' int2str(n) ', ' int2str(k) ': ' num2str(cost-cost_theory) ', ' ...
                  num2str(cost-cost_numerical)])
               disp([num2str(vecnorm(dw_numerical)'*vecnorm(dw_theory))])
            end % bool_numerical_derivative
         end % k=1:K
      end % n=1:N
      asdf=1;
   end % nargout>2
end
return