

function test_randmv_laplace
help randmv_laplace
disp('Executing internal test function for randmv_laplace.')
T=1e6;
dim=2;
Nbins=[100 100];

Gamm=[1 0.5; 0.5 1];
Gamm=Gamm/sqrt(det(Gamm));
Gamm=eye(dim);
lambd=1;
mu=[0 2]';
Z=randmv_laplace(dim,T,'Gamma',Gamm,'lambda',lambd,'mu',mu);

figure
[hist_out,hist_bins]=hist3(Z','Nbins',Nbins);
imagesc(hist_bins{1},hist_bins{2},hist_out')
axis xy; colorbar
xlabel('Z(1)')
ylabel('Z(2)')
title(['Histogram of Multivariate Laplace'])

[z1,z2]=meshgrid(hist_bins{1},hist_bins{2});
f=pdf_mvlaplace([z1(:)'; z2(:)'],lambd,Gamm,mu);

figure
f=reshape(f,length(hist_bins{1}),length(hist_bins{2}));
imagesc(hist_bins{1},hist_bins{2}, f)
axis xy; colorbar
xlabel('Z(1)')
ylabel('Z(2)')
title(['pdf of Multivariate Laplace'])

return
